#if !defined(NAMQH_INCLUDED)             /* File not yet included?      */
   #define NAMQH_INCLUDED                /* Show file now included      */

/*
** Natural C language interface functions
*/

#if defined(__cplusplus)
   extern "C" {
#endif

NATFCT NAMQBACK  NATARGDCL(nparm, parmptr, parmdec);
NATFCT NAMQBEGIN NATARGDCL(nparm, parmptr, parmdec);
NATFCT NAMQCLOSE NATARGDCL(nparm, parmptr, parmdec);
NATFCT NAMQCMIT  NATARGDCL(nparm, parmptr, parmdec);
NATFCT NAMQCONN  NATARGDCL(nparm, parmptr, parmdec);
NATFCT NAMQDISC  NATARGDCL(nparm, parmptr, parmdec);
NATFCT NAMQGET   NATARGDCL(nparm, parmptr, parmdec);
NATFCT NAMQOPEN  NATARGDCL(nparm, parmptr, parmdec);
NATFCT NAMQPUT   NATARGDCL(nparm, parmptr, parmdec);
NATFCT NAMQPUT1  NATARGDCL(nparm, parmptr, parmdec);

#if !defined(NAMQ_ONLY)                   /* Only include NAMQxxx functions? */

/*
** Functions to provide mapping of Natural c language interface to MQ calls
*/

void mq_back (MQHCONN con_hndl, MQLONG *cc, MQLONG *rc);
void mq_begin (MQHCONN con_hndl, MQBO *begin_options, MQLONG *cc, MQLONG *rc);
void mq_close (MQHCONN con_hndl, MQHOBJ * obj_hndl, MQLONG options,
                MQLONG *cc, MQLONG *rc);
void mq_cmit (MQHCONN con_hndl, MQLONG *cc, MQLONG *rc);
void mq_connect (MQHCONN * con_hndl, MQCHAR48 con_name, MQLONG *cc, MQLONG *rc);
void mq_disconnect (MQHCONN * con_hndl, MQLONG *cc, MQLONG *rc) ;
void mq_get (MQHCONN con_hndl, MQHOBJ obj_hndl, MQMD * msg_desc,
               MQGMO * get_options, MQLONG buf_length, MQBYTE * buffer,
               MQLONG * data_length, MQLONG *cc, MQLONG *rc);
void mq_open (MQHCONN con_hndl, MQOD * obj_desc, MQLONG options,
                MQHOBJ * obj_hndl, MQLONG *cc, MQLONG *rc);
void mq_put (MQHCONN con_hndl, MQHOBJ obj_hndl, MQMD * msg_desc,
               MQPMO * put_options, MQLONG buf_length, MQBYTE * buffer,
               MQLONG *cc, MQLONG *rc);
void mq_put1 (MQHCONN con_hndl, MQOD * obj_desc, MQMD * msg_desc,
               MQPMO * put_options, MQLONG buf_length, MQBYTE * buffer,
               MQLONG *cc, MQLONG *rc);

/*
** Utility functions
*/

void dbgtrunc(char *dbgdata, char *source, int maxlength, int minlength);
FILE *dbgopen();
void dbgclose();

#endif                                   /* Only include NAMQxxx functions? */

#if defined(__cplusplus)
   }
#endif

/*********************************************************************/
/*  End of NAMQ                                                      */
/*********************************************************************/

#endif  /* End of header file */